function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function login() {
        openWindow(Alloy.createController("login").getView());
    }
    function drawRoute() {
        Ti.App.fireEvent("closeWin", {});
        goHome();
        setTimeout(function() {
            Ti.App.fireEvent("showRoute", {
                what: "show"
            });
        }, 200);
    }
    function cancelRoute() {
        goHome();
        setTimeout(function() {
            Ti.App.fireEvent("showRoute", {
                what: "cancel"
            });
        }, 200);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "menu_login";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.v_container = Ti.UI.createView({
        id: "v_container",
        layout: "vertical",
        top: "20dp"
    });
    $.__views.v_container && $.addTopLevelView($.__views.v_container);
    $.__views.v_login = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_login",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_login);
    login ? $.__views.v_login.addEventListener("click", login) : __defers["$.__views.v_login!click!login"] = true;
    $.__views.b_login = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/login.png",
        id: "b_login"
    });
    $.__views.v_login.add($.__views.b_login);
    $.__views.lbl_login = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Login",
        id: "lbl_login"
    });
    $.__views.v_login.add($.__views.lbl_login);
    $.__views.v_route = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_route",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_route);
    drawRoute ? $.__views.v_route.addEventListener("click", drawRoute) : __defers["$.__views.v_route!click!drawRoute"] = true;
    $.__views.b_route = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/egnos.png",
        id: "b_route"
    });
    $.__views.v_route.add($.__views.b_route);
    $.__views.lbl_route = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Draw route",
        id: "lbl_route"
    });
    $.__views.v_route.add($.__views.lbl_route);
    $.__views.v_cancel = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_cancel",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_cancel);
    cancelRoute ? $.__views.v_cancel.addEventListener("click", cancelRoute) : __defers["$.__views.v_cancel!click!cancelRoute"] = true;
    $.__views.b_cancel = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/cancel_icon.png",
        id: "b_cancel"
    });
    $.__views.v_cancel.add($.__views.b_cancel);
    $.__views.lbl_cancel = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Cancel route",
        id: "lbl_cancel"
    });
    $.__views.v_cancel.add($.__views.lbl_cancel);
    exports.destroy = function() {};
    _.extend($, $.__views);
    require("eu.ilocate.toolkit");
    require("api");
    __defers["$.__views.v_login!click!login"] && $.__views.v_login.addEventListener("click", login);
    __defers["$.__views.v_route!click!drawRoute"] && $.__views.v_route.addEventListener("click", drawRoute);
    __defers["$.__views.v_cancel!click!cancelRoute"] && $.__views.v_cancel.addEventListener("click", cancelRoute);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;