function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function update_url() {
        Alloy.Globals.route_url = $.field_url.value;
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "menu_url";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win_url = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        id: "win_url",
        layout: "vertical"
    });
    $.__views.win_url && $.addTopLevelView($.__views.win_url);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_url
    });
    $.__views.v_action_bar.setParent($.__views.win_url);
    $.__views.v_back_search = Ti.UI.createView({
        id: "v_back_search"
    });
    $.__views.win_url.add($.__views.v_back_search);
    $.__views.v_search = Ti.UI.createView({
        left: "20dp",
        right: "20dp",
        height: "40dp",
        borderRadius: "15dp",
        borderWidth: 1,
        borderColor: "gray",
        id: "v_search"
    });
    $.__views.v_back_search.add($.__views.v_search);
    $.__views.field_url = Ti.UI.createTextField({
        height: "40dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderColor: "transparent",
        color: "black",
        backgroundColor: "transparent",
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        left: "40dp",
        right: "10dp",
        id: "field_url"
    });
    $.__views.v_search.add($.__views.field_url);
    $.__views.b_url = Ti.UI.createButton({
        width: "95%",
        height: "50dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "340dp",
        left: "5dp",
        right: "5dp",
        backgroundImage: "/footer.jpg",
        title: "Update url",
        id: "b_url"
    });
    $.__views.v_back_search.add($.__views.b_url);
    update_url ? $.__views.b_url.addEventListener("click", update_url) : __defers["$.__views.b_url!click!update_url"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.field_url.value = Alloy.Globals.route_url;
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function() {
        close($.win_url);
    });
    $.win_url.addEventListener("close", function() {
        $.v_action_bar.getView("action_bar").removeEventListener("onButtonClick", function() {});
    });
    __defers["$.__views.b_url!click!update_url"] && $.__views.b_url.addEventListener("click", update_url);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;