function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function onClick() {
        "pass" == args.operation ? forgotPassword() : register();
    }
    function forgotPassword() {
        $.v_loader.visible = true;
        $.activityIndicator.show();
        if ($.field_email.value.length > 5) {
            var api = require("api");
            var params = {
                email: $.field_email.value,
                subject: "iLocate registration",
                message: "Follow this link to complete the registration to the iLocate service"
            };
            api.forgotPassword(JSON.stringify(params), {
                onSuccess: function() {
                    $.activityIndicator.hide();
                    $.v_loader.visible = false;
                    openAlertWindow("/happy_face.png", "Check your email to reset your password!", "Got it!");
                    setTimeout(function() {
                        close($.win_register);
                    }, 500);
                },
                onError: function(e) {
                    $.activityIndicator.hide();
                    $.v_loader.visible = false;
                    alert(JSON.stringify(e));
                }
            });
        }
    }
    function register() {
        $.v_loader.visible = true;
        $.activityIndicator.show();
        if ($.field_email.value.length > 5) {
            var api = require("api");
            var params = {
                email: $.field_email.value,
                subject: "iLocate registration",
                message: "Follow this link to complete the registration to the iLocate service"
            };
            api.registerUser(JSON.stringify(params), {
                onSuccess: function() {
                    $.activityIndicator.hide();
                    $.v_loader.visible = false;
                    openAlertWindow("/happy_face.png", "Check your email and complete the registration to the iLocate service!", "Got it!");
                    setTimeout(function() {
                        close($.win_register);
                    }, 500);
                },
                onError: function(e) {
                    $.activityIndicator.hide();
                    $.v_loader.visible = false;
                    alert(JSON.stringify(e));
                }
            });
        }
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "register";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win_register = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        titleImage: "/icon_navbar.png",
        id: "win_register"
    });
    $.__views.win_register && $.addTopLevelView($.__views.win_register);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_register
    });
    $.__views.v_action_bar.setParent($.__views.win_register);
    $.__views.v_container = Ti.UI.createView({
        top: "60dp",
        left: 0,
        right: 0,
        bottom: 0,
        backgroundColor: "white",
        id: "v_container"
    });
    $.__views.win_register.add($.__views.v_container);
    $.__views.lbl_email = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        top: "100dp",
        left: "20dp",
        text: "Email",
        id: "lbl_email"
    });
    $.__views.win_register.add($.__views.lbl_email);
    $.__views.custom_txt_field = Ti.UI.createView({
        top: "150dp",
        left: "5dp",
        right: "7dp",
        height: "40dp",
        id: "custom_txt_field"
    });
    $.__views.win_register.add($.__views.custom_txt_field);
    $.__views.field_email = Ti.UI.createTextField({
        height: "40dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderColor: "#c5c5c5",
        color: "black",
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        borderRadius: 5,
        borderWidth: 1,
        keyboardType: Titanium.UI.KEYBOARD_EMAIL,
        returnKeyType: Titanium.UI.RETURNKEY_NEXT,
        left: "20dp",
        right: "20dp",
        id: "field_email",
        value: "erinda.jaupaj@u-hopper.com"
    });
    $.__views.custom_txt_field.add($.__views.field_email);
    $.__views.b_register = Ti.UI.createButton({
        width: "95%",
        height: "50dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "250dp",
        left: "20dp",
        right: "20dp",
        backgroundImage: "/footer.jpg",
        title: "Register",
        id: "b_register"
    });
    $.__views.win_register.add($.__views.b_register);
    onClick ? $.__views.b_register.addEventListener("click", onClick) : __defers["$.__views.b_register!click!onClick"] = true;
    $.__views.v_loader = Ti.UI.createView({
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        backgroundColor: "black",
        opacity: .7,
        visible: false,
        id: "v_loader"
    });
    $.__views.win_register.add($.__views.v_loader);
    $.__views.activityIndicator = Ti.UI.createActivityIndicator({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: 26,
            fontWeight: "bold"
        },
        color: "white",
        height: Ti.UI.SIZE,
        width: Ti.UI.SIZE,
        style: Ti.UI.ActivityIndicatorStyle.DARK,
        id: "activityIndicator",
        message: "Loading..."
    });
    $.__views.win_register.add($.__views.activityIndicator);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    $.activityIndicator.hide();
    "pass" == args.operation && ($.b_register.title = "Recover Password");
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function(e) {
        "close" == e.action ? close($.win_register) : goToSettings();
    });
    __defers["$.__views.b_register!click!onClick"] && $.__views.b_register.addEventListener("click", onClick);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;