function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "settings";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    $.__views.win_settings = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        id: "win_settings"
    });
    $.__views.win_settings && $.addTopLevelView($.__views.win_settings);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_settings
    });
    $.__views.v_action_bar.setParent($.__views.win_settings);
    $.__views.v_container = Ti.UI.createView({
        id: "v_container",
        layout: "vertical",
        backgroundColor: "white",
        top: "60dp"
    });
    $.__views.win_settings.add($.__views.v_container);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function(e) {
        "close" == e.action ? close($.win_settings) : openWindow(Alloy.createController("settings").getView());
    });
    $.win_settings.addEventListener("close", function() {
        $.v_action_bar.getView("action_bar").removeEventListener("onButtonClick", function() {});
    });
    Ti.App.addEventListener("closeWin", function() {
        close($.win_settings);
        Ti.App.fireEvent("navigation", "resume");
    });
    $.v_container.add(Alloy.Globals.TOKEN.length > 5 ? Alloy.createController("menu_logout").getView() : Alloy.createController("menu_login").getView());
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;