module.exports = function e(t, n, r) {
    function s(o, u) {
        if (!n[o]) {
            if (!t[o]) {
                var a = "function" == typeof require && require;
                if (!u && a) return a(o, !0);
                if (i) return i(o, !0);
                var f = new Error("Cannot find module '" + o + "'");
                throw f.code = "MODULE_NOT_FOUND", f;
            }
            var l = n[o] = {
                exports: {}
            };
            t[o][0].call(l.exports, function(e) {
                var n = t[o][1][e];
                return s(n ? n : e);
            }, l, l.exports, e, t, n, r);
        }
        return n[o].exports;
    }
    var i = "function" == typeof require && require;
    for (var o = 0; o < r.length; o++) s(r[o]);
    return s;
}({
    1: [ function(require, module) {
        module.exports = "function" == typeof Object.create ? function(ctor, superCtor) {
            ctor.super_ = superCtor;
            ctor.prototype = Object.create(superCtor.prototype, {
                constructor: {
                    value: ctor,
                    enumerable: false,
                    writable: true,
                    configurable: true
                }
            });
        } : function(ctor, superCtor) {
            ctor.super_ = superCtor;
            var TempCtor = function() {};
            TempCtor.prototype = superCtor.prototype;
            ctor.prototype = new TempCtor();
            ctor.prototype.constructor = ctor;
        };
    }, {} ],
    2: [ function(require, module) {
        function noop() {}
        var process = module.exports = {};
        process.nextTick = function() {
            var canSetImmediate = "undefined" != typeof window && window.setImmediate;
            var canMutationObserver = "undefined" != typeof window && window.MutationObserver;
            var canPost = "undefined" != typeof window && window.postMessage && window.addEventListener;
            if (canSetImmediate) return function(f) {
                return window.setImmediate(f);
            };
            var queue = [];
            if (canMutationObserver) {
                var hiddenDiv = document.createElement("div");
                var observer = new MutationObserver(function() {
                    var queueList = queue.slice();
                    queue.length = 0;
                    queueList.forEach(function(fn) {
                        fn();
                    });
                });
                observer.observe(hiddenDiv, {
                    attributes: true
                });
                return function(fn) {
                    queue.length || hiddenDiv.setAttribute("yes", "no");
                    queue.push(fn);
                };
            }
            if (canPost) {
                window.addEventListener("message", function(ev) {
                    var source = ev.source;
                    if ((source === window || null === source) && "process-tick" === ev.data) {
                        ev.stopPropagation();
                        if (queue.length > 0) {
                            var fn = queue.shift();
                            fn();
                        }
                    }
                }, true);
                return function(fn) {
                    queue.push(fn);
                    window.postMessage("process-tick", "*");
                };
            }
            return function(fn) {
                setTimeout(fn, 0);
            };
        }();
        process.title = "browser";
        process.browser = true;
        process.env = {};
        process.argv = [];
        process.on = noop;
        process.addListener = noop;
        process.once = noop;
        process.off = noop;
        process.removeListener = noop;
        process.removeAllListeners = noop;
        process.emit = noop;
        process.binding = function() {
            throw new Error("process.binding is not supported");
        };
        process.cwd = function() {
            return "/";
        };
        process.chdir = function() {
            throw new Error("process.chdir is not supported");
        };
    }, {} ],
    3: [ function(require, module) {
        module.exports = function(arg) {
            return arg && "object" == typeof arg && "function" == typeof arg.copy && "function" == typeof arg.fill && "function" == typeof arg.readUInt8;
        };
    }, {} ],
    4: [ function(require, module, exports) {
        (function(process, global) {
            function inspect(obj, opts) {
                var ctx = {
                    seen: [],
                    stylize: stylizeNoColor
                };
                arguments.length >= 3 && (ctx.depth = arguments[2]);
                arguments.length >= 4 && (ctx.colors = arguments[3]);
                isBoolean(opts) ? ctx.showHidden = opts : opts && exports._extend(ctx, opts);
                isUndefined(ctx.showHidden) && (ctx.showHidden = false);
                isUndefined(ctx.depth) && (ctx.depth = 2);
                isUndefined(ctx.colors) && (ctx.colors = false);
                isUndefined(ctx.customInspect) && (ctx.customInspect = true);
                ctx.colors && (ctx.stylize = stylizeWithColor);
                return formatValue(ctx, obj, ctx.depth);
            }
            function stylizeWithColor(str, styleType) {
                var style = inspect.styles[styleType];
                return style ? "[" + inspect.colors[style][0] + "m" + str + "[" + inspect.colors[style][1] + "m" : str;
            }
            function stylizeNoColor(str) {
                return str;
            }
            function arrayToHash(array) {
                var hash = {};
                array.forEach(function(val) {
                    hash[val] = true;
                });
                return hash;
            }
            function formatValue(ctx, value, recurseTimes) {
                if (ctx.customInspect && value && isFunction(value.inspect) && value.inspect !== exports.inspect && !(value.constructor && value.constructor.prototype === value)) {
                    var ret = value.inspect(recurseTimes, ctx);
                    isString(ret) || (ret = formatValue(ctx, ret, recurseTimes));
                    return ret;
                }
                var primitive = formatPrimitive(ctx, value);
                if (primitive) return primitive;
                var keys = Object.keys(value);
                var visibleKeys = arrayToHash(keys);
                ctx.showHidden && (keys = Object.getOwnPropertyNames(value));
                if (isError(value) && (keys.indexOf("message") >= 0 || keys.indexOf("description") >= 0)) return formatError(value);
                if (0 === keys.length) {
                    if (isFunction(value)) {
                        var name = value.name ? ": " + value.name : "";
                        return ctx.stylize("[Function" + name + "]", "special");
                    }
                    if (isRegExp(value)) return ctx.stylize(RegExp.prototype.toString.call(value), "regexp");
                    if (isDate(value)) return ctx.stylize(Date.prototype.toString.call(value), "date");
                    if (isError(value)) return formatError(value);
                }
                var base = "", array = false, braces = [ "{", "}" ];
                if (isArray(value)) {
                    array = true;
                    braces = [ "[", "]" ];
                }
                if (isFunction(value)) {
                    var n = value.name ? ": " + value.name : "";
                    base = " [Function" + n + "]";
                }
                isRegExp(value) && (base = " " + RegExp.prototype.toString.call(value));
                isDate(value) && (base = " " + Date.prototype.toUTCString.call(value));
                isError(value) && (base = " " + formatError(value));
                if (0 === keys.length && (!array || 0 == value.length)) return braces[0] + base + braces[1];
                if (0 > recurseTimes) return isRegExp(value) ? ctx.stylize(RegExp.prototype.toString.call(value), "regexp") : ctx.stylize("[Object]", "special");
                ctx.seen.push(value);
                var output;
                output = array ? formatArray(ctx, value, recurseTimes, visibleKeys, keys) : keys.map(function(key) {
                    return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
                });
                ctx.seen.pop();
                return reduceToSingleString(output, base, braces);
            }
            function formatPrimitive(ctx, value) {
                if (isUndefined(value)) return ctx.stylize("undefined", "undefined");
                if (isString(value)) {
                    var simple = "'" + JSON.stringify(value).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
                    return ctx.stylize(simple, "string");
                }
                if (isNumber(value)) return ctx.stylize("" + value, "number");
                if (isBoolean(value)) return ctx.stylize("" + value, "boolean");
                if (isNull(value)) return ctx.stylize("null", "null");
            }
            function formatError(value) {
                return "[" + Error.prototype.toString.call(value) + "]";
            }
            function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
                var output = [];
                for (var i = 0, l = value.length; l > i; ++i) output.push(hasOwnProperty(value, String(i)) ? formatProperty(ctx, value, recurseTimes, visibleKeys, String(i), true) : "");
                keys.forEach(function(key) {
                    key.match(/^\d+$/) || output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, key, true));
                });
                return output;
            }
            function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
                var name, str, desc;
                desc = Object.getOwnPropertyDescriptor(value, key) || {
                    value: value[key]
                };
                desc.get ? str = desc.set ? ctx.stylize("[Getter/Setter]", "special") : ctx.stylize("[Getter]", "special") : desc.set && (str = ctx.stylize("[Setter]", "special"));
                hasOwnProperty(visibleKeys, key) || (name = "[" + key + "]");
                if (!str) if (ctx.seen.indexOf(desc.value) < 0) {
                    str = isNull(recurseTimes) ? formatValue(ctx, desc.value, null) : formatValue(ctx, desc.value, recurseTimes - 1);
                    str.indexOf("\n") > -1 && (str = array ? str.split("\n").map(function(line) {
                        return "  " + line;
                    }).join("\n").substr(2) : "\n" + str.split("\n").map(function(line) {
                        return "   " + line;
                    }).join("\n"));
                } else str = ctx.stylize("[Circular]", "special");
                if (isUndefined(name)) {
                    if (array && key.match(/^\d+$/)) return str;
                    name = JSON.stringify("" + key);
                    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
                        name = name.substr(1, name.length - 2);
                        name = ctx.stylize(name, "name");
                    } else {
                        name = name.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
                        name = ctx.stylize(name, "string");
                    }
                }
                return name + ": " + str;
            }
            function reduceToSingleString(output, base, braces) {
                var numLinesEst = 0;
                var length = output.reduce(function(prev, cur) {
                    numLinesEst++;
                    cur.indexOf("\n") >= 0 && numLinesEst++;
                    return prev + cur.replace(/\u001b\[\d\d?m/g, "").length + 1;
                }, 0);
                if (length > 60) return braces[0] + ("" === base ? "" : base + "\n ") + " " + output.join(",\n  ") + " " + braces[1];
                return braces[0] + base + " " + output.join(", ") + " " + braces[1];
            }
            function isArray(ar) {
                return Array.isArray(ar);
            }
            function isBoolean(arg) {
                return "boolean" == typeof arg;
            }
            function isNull(arg) {
                return null === arg;
            }
            function isNullOrUndefined(arg) {
                return null == arg;
            }
            function isNumber(arg) {
                return "number" == typeof arg;
            }
            function isString(arg) {
                return "string" == typeof arg;
            }
            function isSymbol(arg) {
                return "symbol" == typeof arg;
            }
            function isUndefined(arg) {
                return void 0 === arg;
            }
            function isRegExp(re) {
                return isObject(re) && "[object RegExp]" === objectToString(re);
            }
            function isObject(arg) {
                return "object" == typeof arg && null !== arg;
            }
            function isDate(d) {
                return isObject(d) && "[object Date]" === objectToString(d);
            }
            function isError(e) {
                return isObject(e) && ("[object Error]" === objectToString(e) || e instanceof Error);
            }
            function isFunction(arg) {
                return "function" == typeof arg;
            }
            function isPrimitive(arg) {
                return null === arg || "boolean" == typeof arg || "number" == typeof arg || "string" == typeof arg || "symbol" == typeof arg || "undefined" == typeof arg;
            }
            function objectToString(o) {
                return Object.prototype.toString.call(o);
            }
            function pad(n) {
                return 10 > n ? "0" + n.toString(10) : n.toString(10);
            }
            function timestamp() {
                var d = new Date();
                var time = [ pad(d.getHours()), pad(d.getMinutes()), pad(d.getSeconds()) ].join(":");
                return [ d.getDate(), months[d.getMonth()], time ].join(" ");
            }
            function hasOwnProperty(obj, prop) {
                return Object.prototype.hasOwnProperty.call(obj, prop);
            }
            var formatRegExp = /%[sdj%]/g;
            exports.format = function(f) {
                if (!isString(f)) {
                    var objects = [];
                    for (var i = 0; i < arguments.length; i++) objects.push(inspect(arguments[i]));
                    return objects.join(" ");
                }
                var i = 1;
                var args = arguments;
                var len = args.length;
                var str = String(f).replace(formatRegExp, function(x) {
                    if ("%%" === x) return "%";
                    if (i >= len) return x;
                    switch (x) {
                      case "%s":
                        return String(args[i++]);

                      case "%d":
                        return Number(args[i++]);

                      case "%j":
                        try {
                            return JSON.stringify(args[i++]);
                        } catch (_) {
                            return "[Circular]";
                        }

                      default:
                        return x;
                    }
                });
                for (var x = args[i]; len > i; x = args[++i]) str += isNull(x) || !isObject(x) ? " " + x : " " + inspect(x);
                return str;
            };
            exports.deprecate = function(fn, msg) {
                function deprecated() {
                    if (!warned) {
                        if (process.throwDeprecation) throw new Error(msg);
                        process.traceDeprecation ? console.trace(msg) : console.error(msg);
                        warned = true;
                    }
                    return fn.apply(this, arguments);
                }
                if (isUndefined(global.process)) return function() {
                    return exports.deprecate(fn, msg).apply(this, arguments);
                };
                if (true === process.noDeprecation) return fn;
                var warned = false;
                return deprecated;
            };
            var debugs = {};
            var debugEnviron;
            exports.debuglog = function(set) {
                isUndefined(debugEnviron) && (debugEnviron = process.env.NODE_DEBUG || "");
                set = set.toUpperCase();
                if (!debugs[set]) if (new RegExp("\\b" + set + "\\b", "i").test(debugEnviron)) {
                    var pid = process.pid;
                    debugs[set] = function() {
                        var msg = exports.format.apply(exports, arguments);
                        console.error("%s %d: %s", set, pid, msg);
                    };
                } else debugs[set] = function() {};
                return debugs[set];
            };
            exports.inspect = inspect;
            inspect.colors = {
                bold: [ 1, 22 ],
                italic: [ 3, 23 ],
                underline: [ 4, 24 ],
                inverse: [ 7, 27 ],
                white: [ 37, 39 ],
                grey: [ 90, 39 ],
                black: [ 30, 39 ],
                blue: [ 34, 39 ],
                cyan: [ 36, 39 ],
                green: [ 32, 39 ],
                magenta: [ 35, 39 ],
                red: [ 31, 39 ],
                yellow: [ 33, 39 ]
            };
            inspect.styles = {
                special: "cyan",
                number: "yellow",
                "boolean": "yellow",
                undefined: "grey",
                "null": "bold",
                string: "green",
                date: "magenta",
                regexp: "red"
            };
            exports.isArray = isArray;
            exports.isBoolean = isBoolean;
            exports.isNull = isNull;
            exports.isNullOrUndefined = isNullOrUndefined;
            exports.isNumber = isNumber;
            exports.isString = isString;
            exports.isSymbol = isSymbol;
            exports.isUndefined = isUndefined;
            exports.isRegExp = isRegExp;
            exports.isObject = isObject;
            exports.isDate = isDate;
            exports.isError = isError;
            exports.isFunction = isFunction;
            exports.isPrimitive = isPrimitive;
            exports.isBuffer = require("./support/isBuffer");
            var months = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];
            exports.log = function() {
                console.log("%s - %s", timestamp(), exports.format.apply(exports, arguments));
            };
            exports.inherits = require("inherits");
            exports._extend = function(origin, add) {
                if (!add || !isObject(add)) return origin;
                var keys = Object.keys(add);
                var i = keys.length;
                while (i--) origin[keys[i]] = add[keys[i]];
                return origin;
            };
        }).call(this, require("_process"), "undefined" != typeof global ? global : "undefined" != typeof self ? self : "undefined" != typeof window ? window : {});
    }, {
        "./support/isBuffer": 3,
        _process: 2,
        inherits: 1
    } ],
    5: [ function(require, module, exports) {
        function maybeCallback(o) {
            return o && util.isFunction(o) ? o : function(err) {
                if (err) throw err;
            };
        }
        function assertFlags(flags) {
            var tiMode = MODE_MAP[flags];
            if (null == tiMode) throw new Error("Unknown file open flag: " + flags);
            return tiMode;
        }
        function assertEncoding(encoding) {
            if (encoding && -1 === ENCODINGS.indexOf(encoding.toLowerCase())) throw new Error("Unknown encoding: " + encoding);
        }
        function convertBuffer(buffer, encoding) {
            switch (encoding.toLowerCase()) {
              case "ascii":
              case "binary":
                var ret = "";
                for (var i = 0; i < buffer.length; i++) ret += String.fromCharCode(Ti.Codec.decodeNumber({
                    source: buffer,
                    type: Ti.Codec.TYPE_BYTE,
                    position: i
                }));
                return ret;

              case "utf8":
              case "utf-8":
                return buffer.toString();

              case "base64":
                return Ti.Utils.base64encode(buffer.toString()).toString();

              default:
                throw new Error("Unknown encoding: " + encoding);
            }
        }
        var $F = Ti.Filesystem, fs = exports, util = require("util");
        var IS_ANDROID = true;
        var MODE_MAP = {};
        MODE_MAP["r"] = MODE_MAP["r+"] = MODE_MAP["rs"] = MODE_MAP["rs+"] = $F.MODE_READ;
        MODE_MAP["w"] = MODE_MAP["w+"] = MODE_MAP["wx"] = MODE_MAP["wx+"] = $F.MODE_WRITE;
        MODE_MAP["a"] = MODE_MAP["a+"] = MODE_MAP["ax"] = MODE_MAP["ax+"] = $F.MODE_APPEND;
        fs.Stats = function(path) {
            this.__file = null;
            this.dev = 0;
            this.ino = 0;
            this.nlink = 0;
            this.uid = 0;
            this.gid = 0;
            this.rdev = 0;
            this.size = 0;
            this.blksize = 4096;
            this.blocks = 8;
            this.ctime = this.atime = this.mtime = 0;
            if (path) {
                this.__file = $F.getFile(path);
                if (!this.__file.exists()) throw new Error("file does not exist");
                this.size = this.__file.size;
                this.mode = 0;
                this.ctime = new Date(this.__file.createTimestamp());
                this.atime = this.mtime = new Date(this.__file.modificationTimestamp());
            }
        };
        fs.Stats.prototype.isDirectory = function() {
            return this.__file.isDirectory();
        };
        fs.Stats.prototype.isFile = function() {
            return this.__file.isFile();
        };
        fs.Stats.prototype.isBlockDevice = function() {
            return false;
        };
        fs.Stats.prototype.isCharacterDevice = function() {
            return false;
        };
        fs.Stats.prototype.isSymbolicLink = function() {
            return this.__file.symbolicLink;
        };
        fs.Stats.prototype.isFIFO = function() {
            return false;
        };
        fs.Stats.prototype.isSocket = function() {
            return false;
        };
        fs.exists = function(path, callback) {
            setTimeout(function() {
                return callback(fs.existsSync(path));
            }, 0);
        };
        fs.existsSync = function(path) {
            return $F.getFile(path).exists();
        };
        fs.readFile = function(path, options) {
            var callback = maybeCallback(arguments[arguments.length - 1]);
            if (!options || util.isFunction(options)) options = {
                encoding: null,
                flag: "r"
            }; else if (util.isString(options)) options = {
                encoding: options,
                flag: "r"
            }; else if (!util.isObject(options)) throw new TypeError("Bad arguments");
            var encoding = options.encoding, flag = options.flag || "r";
            assertEncoding(options.encoding);
            fs.open(path, flag, function(err, fd) {
                if (err) return callback(err);
                fs.fstat(fd, function(err, stats) {
                    if (err) return callback(err);
                    var buffer = Ti.createBuffer({
                        length: stats.size
                    });
                    fs.read(fd, buffer, function(err) {
                        if (err) return callback(err);
                        fs.close(fd, function(err) {
                            if (err) return callback(err);
                            return callback(err, encoding ? convertBuffer(buffer, encoding) : buffer);
                        });
                    });
                });
            });
        };
        fs.readFileSync = function(path, options) {
            if (options) {
                if (util.isString(options)) options = {
                    encoding: options,
                    flag: "r"
                }; else if (!util.isObject(options)) throw new TypeError("Bad arguments");
            } else options = {
                encoding: null,
                flag: "r"
            };
            var encoding = options.encoding, flag = options.flag || "r";
            assertEncoding(options.encoding);
            var fd = fs.openSync(path, flag), size = fs.fstatSync(fd).size, buffer = Ti.createBuffer({
                length: size
            });
            fs.readSync(fd, buffer);
            fs.closeSync(fd);
            return encoding ? convertBuffer(buffer, encoding) : buffer;
        };
        fs.close = function(fd, callback) {
            setTimeout(function() {
                var err = null;
                try {
                    fd.close();
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.closeSync = function(fd) {
            fd.close();
        };
        fs.open = function(path, flags, mode, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            (!mode || util.isFunction(mode)) && (mode = null);
            setTimeout(function() {
                var fd = null, err = null;
                try {
                    fd = fs.openSync(path, flags, mode);
                } catch (e) {
                    err = e;
                }
                return callback(err, fd);
            }, 0);
        };
        fs.openSync = function(path, flags) {
            var tiMode = assertFlags(flags), file = $F.getFile(path), fd = file.open(tiMode);
            fd.__path = path;
            return fd;
        };
        fs.read = function(fd, buffer, offset, length, position, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            util.isFunction(position) && (position = void 0);
            util.isFunction(length) && (length = void 0);
            util.isFunction(offset) && (offset = void 0);
            setTimeout(function() {
                var bytes = null, err = null;
                try {
                    bytes = fs.readSync(fd, buffer, offset, length, position);
                } catch (e) {
                    err = e;
                }
                return callback(err, bytes, buffer);
            }, 0);
        };
        fs.readSync = IS_ANDROID ? function(fd, buffer, offset, length) {
            return null == offset && null == length ? fd.read(buffer) : fd.read(buffer, offset, length);
        } : function(fd, buffer, offset, length) {
            return fd.read(buffer, offset, length);
        };
        fs.write = function(fd, buffer, offset, length, position, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            util.isFunction(position) && (position = void 0);
            util.isFunction(length) && (length = void 0);
            util.isFunction(offset) && (offset = void 0);
            setTimeout(function() {
                var bytes = null, err = null;
                try {
                    bytes = fs.writeSync(fd, buffer, offset, length, position);
                } catch (e) {
                    err = e;
                }
                return callback(err, bytes, buffer);
            }, 0);
        };
        fs.writeSync = IS_ANDROID ? function(fd, buffer, offset, length) {
            return null == offset && null == length ? fd.write(buffer) : fd.write(buffer, offset, length);
        } : function(fd, buffer, offset, length) {
            return fd.write(buffer, offset, length);
        };
        fs.rename = function(oldPath, newPath, callback) {
            setTimeout(function() {
                var err = null, good = false;
                try {
                    good = $F.getFile(oldPath).move(newPath);
                    console.log("good: " + good);
                    good || (err = new Error("could not move file"));
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.renameSync = function(oldPath, newPath) {
            $F.getFile(oldPath).move(newPath);
        };
        fs.truncate = function(path, len, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            (!len || util.isFunction(len)) && (len = 0);
            len ? fs.open(path, "r", function(err, fd) {
                if (err) return callback(err);
                var buffer = Ti.createBuffer({
                    length: len
                });
                fs.read(fd, buffer, 0, len, function(err, bytes, buffer) {
                    if (err) return callback(err);
                    fs.close(fd, function(err) {
                        if (err) return callback(err);
                        fs.writeFile(path, buffer, callback);
                    });
                });
            }) : fs.writeFile(path, "", callback);
        };
        fs.truncateSync = function(path, len) {
            len = len || 0;
            if (len) {
                var fd = fs.openSync(path, "r"), buffer = Ti.createBuffer({
                    length: len
                });
                fs.readSync(fd, buffer, 0, len);
                fs.closeSync(fd);
                fs.writeFileSync(path, buffer);
            } else fs.writeFileSync(path, "");
        };
        fs.ftruncate = function(fd, len, callback) {
            if (!fd.__path) throw new Error("invalid file descriptor");
            callback = maybeCallback(arguments[arguments.length - 1]);
            (!len || util.isFunction(len)) && (len = 0);
            if (len) {
                var buffer = Ti.createBuffer({
                    length: len
                });
                fs.open(fd.__path, "r", function(err, fd2) {
                    if (err) return callback(err);
                    fs.read(fd2, buffer, 0, len, function(err, bytes, buffer) {
                        if (err) return callback(err);
                        fs.close(fd2, function(err) {
                            if (err) return callback(err);
                            fs.writeFile(fd.__path, buffer, callback);
                        });
                    });
                });
            } else fs.writeFile(fd.__path, "", callback);
        };
        fs.ftruncateSync = function(fd, len) {
            len = len || 0;
            if (!fd.__path) throw new Error("invalid file descriptor");
            if (len) {
                var buffer = Ti.createBuffer({
                    length: len
                }), fd2 = fs.openSync(fd.__path, "r");
                fs.readSync(fd2, buffer, 0, len);
                fs.closeSync(fd2);
                fs.writeFileSync(fd.__path, buffer);
            } else fs.writeFileSync(fd.__path, "");
        };
        fs.rmdir = function(path, callback) {
            setTimeout(function() {
                var err = null;
                try {
                    $F.getFile(path).deleteDirectory() || (err = new Error("could not delete directory"));
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.rmdirSync = function(path) {
            if (!$F.getFile(path).deleteDirectory()) throw new Error("could not delete directory");
        };
        fs.mkdir = IS_ANDROID ? function(path, mode, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            setTimeout(function() {
                var err = null;
                try {
                    $F.getFile(path).createDirectory();
                    if (!$F.getFile(path).exists()) throw new Error("could not create directory");
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        } : function(path, mode, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            setTimeout(function() {
                var err = null;
                try {
                    $F.getFile(path).createDirectory() || (err = new Error("could not create directory"));
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.mkdirSync = IS_ANDROID ? function(path) {
            $F.getFile(path).createDirectory();
            if (!$F.getFile(path).exists()) throw new Error("could not create directory");
        } : function(path) {
            if (!$F.getFile(path).createDirectory()) throw new Error("could not create directory");
        };
        fs.readdir = function(path, callback) {
            setTimeout(function() {
                var files = [], err = null;
                try {
                    files = fs.readdirSync(path);
                } catch (e) {
                    err = e;
                }
                return callback(err, files);
            }, 0);
        };
        fs.readdirSync = function(path) {
            return $F.getFile(path).getDirectoryListing();
        };
        fs.fstat = function(fd, callback) {
            setTimeout(function() {
                var stats = null, err = null;
                try {
                    stats = fs.fstatSync(fd);
                } catch (e) {
                    err = e;
                }
                return callback(err, stats);
            }, 0);
        };
        fs.lstat = function(path, callback) {
            setTimeout(function() {
                var stats = null, err = null;
                try {
                    stats = fs.lstatSync(path);
                } catch (e) {
                    err = e;
                }
                return callback(err, stats);
            }, 0);
        };
        fs.stat = function(path, callback) {
            setTimeout(function() {
                var stats = null, err = null;
                try {
                    stats = fs.statSync(path);
                } catch (e) {
                    err = e;
                }
                return callback(err, stats);
            }, 0);
        };
        fs.fstatSync = function(fd) {
            if (fd.__path) return fs.statSync(fd.__path);
            throw new Error("invalid file descriptor");
        };
        fs.lstatSync = function(path) {
            return fs.statSync(path);
        };
        fs.statSync = function(path) {
            return new fs.Stats(path);
        };
        fs.readlink = function(path, callback) {
            setTimeout(function() {
                var result = null, err = null;
                try {
                    result = fs.readlinkSync(path);
                } catch (e) {
                    err = e;
                }
                return callback(err, result);
            }, 0);
        };
        fs.readlinkSync = function(path) {
            var file = $F.getFile(path);
            if (!file.symbolicLink) throw new Error("invalid argument '" + path + "'");
            return file.resolve();
        };
        fs.unlink = function(path, callback) {
            setTimeout(function() {
                var err = null;
                try {
                    fs.unlinkSync(path);
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.unlinkSync = function(path) {
            var file = $F.getFile(path);
            if (!file.isFile() && !file.symbolicLink) throw new Error("operation not permitted '" + path + "'");
            if (!file.deleteFile()) throw new Error("unable to delete file");
        };
        fs.writeFile = function(path, data, options, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            (!options || util.isFunction(options)) && (options = {});
            setTimeout(function() {
                var err = null;
                try {
                    fs.writeFileSync(path, data, options);
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.writeFileSync = function(path, data, options) {
            options = options || {};
            var buffer, fd = (options.encoding || "utf8", fs.openSync(path, "w"));
            buffer = "Ti.Buffer" === data.apiName ? data : Ti.createBuffer({
                value: data
            });
            fs.writeSync(fd, buffer);
            fs.closeSync(fd);
        };
        fs.appendFile = function(path, data, options) {
            var callback = maybeCallback(arguments[arguments.length - 1]);
            (!options || util.isFunction(options)) && (options = {});
            setTimeout(function() {
                var err = null;
                try {
                    fs.appendFileSync(path, data, options);
                } catch (e) {
                    err = e;
                }
                return callback(err);
            }, 0);
        };
        fs.appendFileSync = function(path, data, options) {
            options = options || {};
            var buffer, fd = (options.encoding || "utf8", fs.openSync(path, "a"));
            buffer = "Ti.Buffer" === data.apiName ? data : Ti.createBuffer({
                value: data
            });
            fs.writeSync(fd, buffer);
            fs.closeSync(fd);
        };
        fs.realpathSync = function(p) {
            return $F.getFile(p).resolve();
        };
        fs.realpath = function(p, cache, cb) {
            cb = maybeCallback(arguments[arguments.length - 1]);
            (!cache || util.isFunction(cache)) && (cache = {});
            setTimeout(function() {
                var err = null, res = null;
                try {
                    res = fs.realpathSync(p, cache);
                } catch (e) {
                    err = e;
                }
                return cb(err, res);
            }, 0);
        };
        fs.createReadStream = function() {
            throw new Error("createReadStream not implemented");
        };
        fs.ReadStream = function() {
            throw new Error("ReadStream not implemented");
        };
        fs.FileReadStream = function() {
            throw new Error("FileReadStream not implemented");
        };
        fs.createWriteStream = function() {
            throw new Error("createWriteStream not implemented");
        };
        fs.WriteStream = function() {
            throw new Error("WriteStream not implemented");
        };
        fs.FileWriteStream = function() {
            throw new Error("FileWriteStream not implemented");
        };
        fs.fsync = function(fd, callback) {
            return callback();
        };
        fs.fsyncSync = function() {};
        fs.fchmod = function(fd, mode, callback) {
            return callback();
        };
        fs.fchmodSync = function() {};
        fs.lchmod = function(path, mode, callback) {
            return callback();
        };
        fs.lchmodSync = function() {};
        fs.chmod = function(path, mode, callback) {
            return callback();
        };
        fs.chmodSync = function() {};
        fs.lchown = function(path, uid, gid, callback) {
            return callback();
        };
        fs.lchownSync = function() {};
        fs.fchown = function(fd, uid, gid, callback) {
            return callback();
        };
        fs.fchownSync = function() {};
        fs.chown = function(path, uid, gid, callback) {
            return callback();
        };
        fs.chownSync = function() {};
        fs.symlink = function() {
            return maybeCallback(arguments[arguments.length - 1])();
        };
        fs.symlinkSync = function() {};
        fs.link = function(srcpath, dstpath, callback) {
            return callback();
        };
        fs.linkSync = function() {};
        fs.watch = function() {};
        fs.watchFile = function() {};
        fs.unwatchFile = function() {};
        fs.utimes = function(path, atime, mtime, callback) {
            return callback();
        };
        fs.utimesSync = function() {};
        fs.futimes = function(fd, atime, mtime, callback) {
            return callback();
        };
        fs.futimesSync = function() {};
        var ENCODINGS = [ "ascii", "utf8", "utf-8", "base64", "binary" ];
    }, {
        util: 4
    } ]
}, {}, [ 5 ])(5);