function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function rememberme() {
        $.remembermeChk.backgroundImage = "/radio_button_check.png";
        $.remembermeChk.value = true;
    }
    function login() {
        var api = require("api");
        api.loginUser($.field_email.value, $.password.value, {
            onSuccess: function(result) {
                Alloy.Globals.TOKEN = result.tokenId;
                $.remembermeChk.value && saveToDb();
                goHome();
            },
            onError: function(e) {
                alert(JSON.stringify(e));
            }
        });
    }
    function saveToDb() {
        Ti.API.info("saving to db");
        var user = Alloy.createModel("user", {
            username: $.field_email.value,
            password: $.password.value
        });
        user.save();
        Alloy.Globals.users.add(user);
    }
    function forgotPassword() {
        openWindow(Alloy.createController("register", {
            operation: "pass"
        }).getView());
    }
    function register() {
        openWindow(Alloy.createController("register", {
            operation: "register"
        }).getView());
    }
    function getLastSavedUser() {
        var users = Alloy.Collections.users;
        users.fetch();
        if (users.at(0)) {
            $.field_email.value = users.at(0).get("username");
            $.password.value = users.at(0).get("password");
            rememberme();
        }
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "login";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win_login = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        titleImage: "/icon_navbar.png",
        layout: "vertical",
        id: "win_login"
    });
    $.__views.win_login && $.addTopLevelView($.__views.win_login);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_login
    });
    $.__views.v_action_bar.setParent($.__views.win_login);
    $.__views.__alloyId0 = Ti.UI.createScrollView({
        scrollType: "vertical",
        backgroundColor: "white",
        id: "__alloyId0"
    });
    $.__views.win_login.add($.__views.__alloyId0);
    $.__views.__alloyId1 = Ti.UI.createView({
        height: "400dp",
        left: "20dp",
        right: "20dp",
        id: "__alloyId1"
    });
    $.__views.__alloyId0.add($.__views.__alloyId1);
    $.__views.lbl_username = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        top: "1dp",
        left: "5dp",
        text: "Username",
        id: "lbl_username"
    });
    $.__views.__alloyId1.add($.__views.lbl_username);
    $.__views.custom_txt_field = Ti.UI.createView({
        top: "30dp",
        left: "5dp",
        right: "7dp",
        height: "40dp",
        id: "custom_txt_field"
    });
    $.__views.__alloyId1.add($.__views.custom_txt_field);
    $.__views.field_email = Ti.UI.createTextField({
        height: "40dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderColor: "#c5c5c5",
        color: "black",
        left: "5dp",
        right: "5dp",
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        borderRadius: 5,
        borderWidth: 1,
        keyboardType: Titanium.UI.KEYBOARD_DEFAULT,
        returnKeyType: Titanium.UI.RETURNKEY_NEXT,
        id: "field_email"
    });
    $.__views.custom_txt_field.add($.__views.field_email);
    $.__views.lbl_password = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        top: "90dp",
        left: "5dp",
        text: "Password",
        id: "lbl_password"
    });
    $.__views.__alloyId1.add($.__views.lbl_password);
    $.__views.custom_pwd_field = Ti.UI.createView({
        top: "120dp",
        left: "5dp",
        right: "7dp",
        height: "40dp",
        id: "custom_pwd_field"
    });
    $.__views.__alloyId1.add($.__views.custom_pwd_field);
    $.__views.password = Ti.UI.createTextField({
        height: "40dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderColor: "#c5c5c5",
        color: "black",
        left: "5dp",
        right: "5dp",
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        borderRadius: 5,
        borderWidth: 1,
        passwordMask: true,
        keyboardType: Titanium.UI.KEYBOARD_DEFAULT,
        returnKeyType: Ti.UI.RETURNKEY_DONE,
        id: "password"
    });
    $.__views.custom_pwd_field.add($.__views.password);
    login ? $.__views.password.addEventListener("return", login) : __defers["$.__views.password!return!login"] = true;
    $.__views.remembermeChk = Ti.UI.createButton({
        width: "25dp",
        height: "25dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "180dp",
        left: "5dp",
        borderColor: "black",
        borderWidth: 1,
        backgroundColor: "white",
        value: false,
        id: "remembermeChk"
    });
    $.__views.__alloyId1.add($.__views.remembermeChk);
    rememberme ? $.__views.remembermeChk.addEventListener("click", rememberme) : __defers["$.__views.remembermeChk!click!rememberme"] = true;
    $.__views.remembermeLbl = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "18dp"
        },
        color: "black",
        top: "180dp",
        left: "35dp",
        text: "Memorizza dati di accesso",
        id: "remembermeLbl"
    });
    $.__views.__alloyId1.add($.__views.remembermeLbl);
    rememberme ? $.__views.remembermeLbl.addEventListener("click", rememberme) : __defers["$.__views.remembermeLbl!click!rememberme"] = true;
    $.__views.lbl_forgot_pass = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "16dp"
        },
        color: "blue",
        top: "220dp",
        right: "5dp",
        text: "Forgot password",
        id: "lbl_forgot_pass"
    });
    $.__views.__alloyId1.add($.__views.lbl_forgot_pass);
    forgotPassword ? $.__views.lbl_forgot_pass.addEventListener("click", forgotPassword) : __defers["$.__views.lbl_forgot_pass!click!forgotPassword"] = true;
    $.__views.buttonLogin = Ti.UI.createButton({
        width: "95%",
        height: "50dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "280dp",
        left: "5dp",
        right: "5dp",
        backgroundImage: "/footer.jpg",
        title: "Accedi",
        id: "buttonLogin"
    });
    $.__views.__alloyId1.add($.__views.buttonLogin);
    login ? $.__views.buttonLogin.addEventListener("click", login) : __defers["$.__views.buttonLogin!click!login"] = true;
    $.__views.buttonRegister = Ti.UI.createButton({
        width: "95%",
        height: "50dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "340dp",
        left: "5dp",
        right: "5dp",
        backgroundImage: "/footer.jpg",
        title: "Register",
        id: "buttonRegister"
    });
    $.__views.__alloyId1.add($.__views.buttonRegister);
    register ? $.__views.buttonRegister.addEventListener("click", register) : __defers["$.__views.buttonRegister!click!register"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    getLastSavedUser();
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function() {
        close($.win_login);
    });
    __defers["$.__views.password!return!login"] && $.__views.password.addEventListener("return", login);
    __defers["$.__views.remembermeChk!click!rememberme"] && $.__views.remembermeChk.addEventListener("click", rememberme);
    __defers["$.__views.remembermeLbl!click!rememberme"] && $.__views.remembermeLbl.addEventListener("click", rememberme);
    __defers["$.__views.lbl_forgot_pass!click!forgotPassword"] && $.__views.lbl_forgot_pass.addEventListener("click", forgotPassword);
    __defers["$.__views.buttonLogin!click!login"] && $.__views.buttonLogin.addEventListener("click", login);
    __defers["$.__views.buttonRegister!click!register"] && $.__views.buttonRegister.addEventListener("click", register);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;