function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function logout() {
        var api = require("api");
        api.logout({
            onSuccess: function() {
                goHome();
                Alloy.Globals.TOKEN = "";
            },
            onError: function() {
                alert("Retry!");
            }
        });
    }
    function modify_url() {
        openWindow(Alloy.createController("menu_url").getView());
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "menu_logout";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.v_container = Ti.UI.createView({
        id: "v_container",
        layout: "vertical",
        top: "20dp"
    });
    $.__views.v_container && $.addTopLevelView($.__views.v_container);
    $.__views.v_egnos = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_egnos",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_egnos);
    $.__views.b_egnos = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/egnos.png",
        id: "b_egnos"
    });
    $.__views.v_egnos.add($.__views.b_egnos);
    $.__views.lbl_egnos = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Egnos Info",
        id: "lbl_egnos"
    });
    $.__views.v_egnos.add($.__views.lbl_egnos);
    $.__views.v_settings = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_settings",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_settings);
    $.__views.b_settings = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/settings.png",
        id: "b_settings"
    });
    $.__views.v_settings.add($.__views.b_settings);
    $.__views.lbl_settings = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Settings",
        id: "lbl_settings"
    });
    $.__views.v_settings.add($.__views.lbl_settings);
    $.__views.v_logout = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_logout",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_logout);
    logout ? $.__views.v_logout.addEventListener("click", logout) : __defers["$.__views.v_logout!click!logout"] = true;
    $.__views.b_logout = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/logout.png",
        id: "b_logout"
    });
    $.__views.v_logout.add($.__views.b_logout);
    $.__views.lbl_logout = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Logout",
        id: "lbl_logout"
    });
    $.__views.v_logout.add($.__views.lbl_logout);
    $.__views.v_url = Ti.UI.createView({
        height: "60dp",
        backgroundSelectedColor: "#c5c5c5",
        id: "v_url",
        layout: "horizontal"
    });
    $.__views.v_container.add($.__views.v_url);
    modify_url ? $.__views.v_url.addEventListener("click", modify_url) : __defers["$.__views.v_url!click!modify_url"] = true;
    $.__views.b_logout = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        backgroundImage: "/logout.png",
        id: "b_logout"
    });
    $.__views.v_url.add($.__views.b_logout);
    $.__views.lbl_url = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        color: "black",
        left: "20dp",
        top: 0,
        bottom: 0,
        touchEnable: false,
        text: "Modify URL",
        id: "lbl_url"
    });
    $.__views.v_url.add($.__views.lbl_url);
    exports.destroy = function() {};
    _.extend($, $.__views);
    __defers["$.__views.v_logout!click!logout"] && $.__views.v_logout.addEventListener("click", logout);
    __defers["$.__views.v_url!click!modify_url"] && $.__views.v_url.addEventListener("click", modify_url);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;