function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function onClick() {
        $.v_retry.fireEvent("onBtnClick", {});
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "retry_error";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.v_retry = Ti.UI.createView({
        backgroundColor: "#f9b700",
        layout: "vertical",
        id: "v_retry"
    });
    $.__views.v_retry && $.addTopLevelView($.__views.v_retry);
    $.__views.img = Ti.UI.createImageView({
        top: "20%",
        image: "/sad_face.png",
        width: "100dp",
        height: "100dp",
        id: "img"
    });
    $.__views.v_retry.add($.__views.img);
    $.__views.lbl_msg = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontWeight: "bold",
            fontSize: "30dp"
        },
        color: "white",
        top: "10%",
        left: "20dp",
        right: "20dp",
        textAlign: "center",
        text: "No wifi connection!",
        id: "lbl_msg"
    });
    $.__views.v_retry.add($.__views.lbl_msg);
    $.__views.btn = Ti.UI.createButton({
        width: "95%",
        height: "50dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        title: "Retry",
        top: "20%",
        left: "20dp",
        right: "20dp",
        bottom: "20dp",
        text: "Retry",
        backgroundColor: "#ff9c03",
        id: "btn"
    });
    $.__views.v_retry.add($.__views.btn);
    onClick ? $.__views.btn.addEventListener("click", onClick) : __defers["$.__views.btn!click!onClick"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    args.image && ($.img.image = args.image);
    args.msg && ($.lbl_msg.text = args.msg);
    args.btn_text && ($.btn.title = args.btn_text);
    __defers["$.__views.btn!click!onClick"] && $.__views.btn.addEventListener("click", onClick);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;