var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

exports.definition = {
    config: {
        columns: {
            id: "INTEGER PRIMARY KEY AUTOINCREMENT",
            street_name: "TEXT",
            relative_direction: "TEXT",
            distance: "REAL",
            latitude: "REAL",
            longitude: "REAL"
        },
        adapter: {
            type: "sql",
            collection_name: "step",
            idAttribute: "id",
            db_name: "db"
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {});
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {});
        return Collection;
    }
};

model = Alloy.M("step", exports.definition, []);

collection = Alloy.C("step", exports.definition, model);

exports.Model = model;

exports.Collection = collection;