var Alloy = require("alloy"), _ = Alloy._, Backbone = Alloy.Backbone;

Alloy.Globals.DEBUG = true;

Alloy.Globals.TOKEN = "";

Alloy.Collections.users = Alloy.createCollection("user");

Alloy.Collections.step = Alloy.createCollection("step");

Alloy.Globals.CACHED_POI = {};

Alloy.Globals.initialize = function() {
    var defaultConfigFile = Ti.Filesystem.getFile(Ti.Filesystem.getResourcesDirectory(), "resourceFiles/default.json");
    var defaultConfigData = defaultConfigFile.read();
    var sdCardPath = Ti.Filesystem.getExternalStorageDirectory();
    var configFileName = "config";
    var configFile = Ti.Filesystem.getFile(sdCardPath + configFileName);
    var configData;
    configFile.exists() || configFile.write(defaultConfigData);
    configData = configFile.read().text;
    return configData;
};

Alloy.Globals.CONFIG = JSON.parse(Alloy.Globals.initialize());

Ti.App.routeIsDrawn = false;

Ti.App.SELECTED_FLOOR = 0;

Alloy.Globals.DESTINATION_LEVEL = -1;

Alloy.Globals.setLevel = function(level) {
    currentFloor = level;
    var msg = level + "";
    Ti.API.debug("[saveBtn-FloorChange] change:" + msg);
    Ti.App.fireEvent("setLevel", {
        level: msg
    });
    Ti.App.SELECTED_FLOOR = currentFloor;
};

Alloy.createController("index");