function cleanSteps() {
    log("DELETING database");
    var db = Ti.Database.open("db");
    db.execute("DELETE FROM step");
    log("Affected Rows in datasync       " + db.getRowsAffected());
    db.close();
}

exports.addstep = function(lssteps) {
    cleanSteps();
    var step = null;
    for (var i in lssteps) {
        step = Alloy.createModel("step", {
            street_name: lssteps[i]["streetName"],
            relative_direction: lssteps[i]["relativeDirection"],
            distance: lssteps[i]["distance"],
            latitude: lssteps[i]["lat"],
            longitude: lssteps[i]["lon"]
        });
        step.save();
        Alloy.Collections.step.add(step);
    }
};

exports.getAllStep = function() {
    var coll_step = Alloy.Collections.step;
    coll_step.fetch();
    return coll_step;
};

exports.flush = function() {
    cleanSteps();
};